#!/usr/bin/perl
#=======================================================================
#Change this enclosed codes to fit your system
#Path to the fgrep command on your system
$fgrep = "/usr/bin/fgrep";

#Enable searching files in users' directories
#push(@userdir, "/teacher");
#push(@userdir, "/student");
#Add more statements if necessary: push(@userdir, "users' directories"); 

#You may need to change these variables to fit your Web server's config.
#$htaccess = '.htaccess';
#$public_html = 'user_www';

#List the Webmaster's Email address so that someone can be blamed when error
$webmaster = 'hybj@wwwhome.fancy.com.tw';
#======================================================================= 

$start = (times)[0];   # Start timing
$filecount=0;  $filesize=0;
&parse_form_data (*SEARCH);
$DOC_ROOT = $SEARCH{'DOC_ROOT'};
$DOC_DIR = $SEARCH{'DOC_DIR'};

chop($label = "$DOC_ROOT$DOC_DIR");
$pubdir = "yes";
$document_root = $label;
#chop($document_root=$label);
open(FILELIST, "ls -1R $document_root |");
while (<FILELIST>) {
  if (/:$/) { 
      $label = $`; 
      if (-e "$label/$htaccess") { $pubdir =""; } else { $pubdir = "yes"; }
  } else {
      next unless $pubdir;
      chop;      
      $_ =~ s/(.*)/$label\/$1/;
      next unless (/.htm$/ || /.html$/ || /.txt$/); 
      $SearchFiles .= "$_" . " ";
      $filecount += 1;      $filesize += -s;
      $here="one";
  }
}

#foreach $udir (@userdir) {
#  $label = $udir;
#  open(FILELIST, "ls -1R $udir |");
#  while (<FILELIST>) {
#      if (/:$/) { 
#          $label = $`;
#          $pubdir = $_ =~ /$public_html/;
#	  if (-e "$label/$htaccess") { $pubdir =""; }
#      } else {
#	  next unless $pubdir;
#          chop;      
#	  $_ =~ s/(.*)/$label\/$1/;
#          next unless (/.htm$/ || /.html$/ || /.txt$/); 
#          $SearchFiles .= "$_" . " ";
#          $filecount += 1;  $filesize += -s;
#	  $here="two";
#      }
#  }
#}

$query = $SEARCH{'query'};
if ($query eq "") {
    &return_error(500, "Search Error", "Please enter a search query.");
} else {
    print "Content-type: text/html","\n\n";
    print "<HTML>", "\n";
    print "<HEAD><TITLE>Search Results</TITLE></HEAD>";
    print "<BODY bgcolor=#ffffc0>", "\n";
    print "<H1>Search results for : <font color=#FF0000>$query</font></H1>";
#    print "SECTION:$SearchFiles,$document_root";
    print "<HR>";
    open (SEARCH, "$fgrep -C -i -n -s $query $SearchFiles |");
#    open (SEARCH, "$fgrep -N2 $query $SearchFiles |");

    $count = 0;
    $matches = 0;
    %accessed_files = ();

    while (<SEARCH>) {
  	if ( ($file, $type, $line) = m|^(/\S+)([\-:])\d+\2(.*)| ) {
	   unless ($count) {
		if (defined ($accessed_files{$file})) {
		   next;
		}  else {
		   $accessed_files{$file} = 1;	
		}

		unless ($file =~ s/^$document_root\/(.*)/$1/)
		{  
                   $file =~ s/^\/(.*)\/(.*)\/$public_html\/(.*)/~$2\/$3/;
		}

		$matches++;
#		print qq|<A HREF="/$file">$file</A><BR><BR>|;
		print qq|<A HREF="$DOC_DIR$file">$file</A><BR><BR>|;
           }
	   $count++;
	   $line =~ s/<(([^>]|\n)*)>/&lt;$1&gt;/g;
	   if ($type eq ":") {
		$line =~ s/($query)/<b><font color=#FF0000>$1<\/font><\/b>/ig;
	   }
	   unless ($line) { next; }        
  	   print $line, "<BR>";
   	} else {
	   if ($count) {
		print "<HR>";
		$count = 0;
	   }
	}
    }
    $end = (times)[0];  # End of timing
    print "<P>", "<HR>";
    printf "It takes %10.2f CPU seconds to search %d files (%d KB in total) ", 
	   $end - $start, $filecount, $filesize/1024;
    printf "with %d files matched!<BR><BR>\n", $matches;
    print "This search engine is powered by a 167-line Perl script!<HR>";
    print "</BODY></HTML>", "\n";    
    close(SEARCH);
}
exit(0);


sub parse_form_data
{
  local (*FORM_DATA) = @_;
  local ( $request_method, $query_string, @key_value_pairs,
	  $key_value, $key, $value);

  $request_method = $ENV{'REQUEST_METHOD'};
  if ($request_method eq "GET") {
     $query_string = $ENV{'QUERY_STRING'};
  } elsif ($request_method eq "POST") {
     read (STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
  } else {
     &return_error (500, "Server Error", 
			"Server uses unsupported method");
  }
  
  @key_value_pairs = split(/&/, $query_string);
  foreach $key_value (@key_value_pairs) {
     ($key, $value) = split (/=/, $key_value);
     $value =~ tr/+/ /;
     $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex($1))/eg; 
     if (defined($FORM_DATA{$key})) {
        $FORM_DATA{$key} = join ("\0",$FORM_DATA{$key}, $value);
     } else {
        $FORM_DATA{$key} = $value;
     }
  }
}

sub return_error
{
  local ($status, $keyword, $message) = @_;
  print "Content-type: text/html", "\n";
  print "Status: ", $status, " ", $keyword, "\n\n";
  print <<End_of_Error;

<title>CGI Program - Unexpected Error</title>
<h1>$keyword</h1>
<hr>$message</hr>
Please Contact $webmaster for more information.

End_of_Error
 
  exit(1);
}
